/* cfilterXCMD.c */
/* Language: MPW-C 3.0 */
/*

	 syntax is:
				cfilter "nocontrols", container
				-- remove control chars (ex. CR from container)
*/

/*-------- Makefile

C -b cfilterXCMD.c -mbg off
Link -w -rt XCMD=10005 
	-m ENTRYPOINT 
	-sg cfilter 
	cfilterXCMD.c.o 
	"{Libraries}HyperXLib.o" 
	"{Libraries}Interface.o" 
	"{CLibraries}StdCLib.o" 
	"{Clibraries}"CSANELib.o 
	"{Clibraries}"Cinterface.o 
	"{CLibraries}CRuntime.o" 
	-o "HyperGCG" 
#-------------------------*/



/*#include <CType.h>*/
#include <Types.h>
#include <Memory.h>
#include <OSUtils.h>
#include <HyperXCmd.h>
#include <ToolUtils.h>



void	upcase(char *s);
void	stripcontrols(XCmdPtr pXCmd);


/* XCMD entry -- MUST BE FIRST CODE IN SEG */

pascal void EntryPoint(XCmdPtr pXCmd)
{
	Ptr  			theMessage;
	char 			message[100];
	Handle		hmsg;
	
	theMessage = *(pXCmd->params[0]);
	strcpy(message,theMessage);
	upcase(message);
	
	if (strcmp(message,"NOCONTROL")==0) stripcontrols(pXCmd);
	else {         
		strcpy(message,"Undefined message in cfilter XCMD"); 
		hmsg = NewHandle(1+strlen(message));
		HLock(hmsg);
		strcpy(*hmsg, message);
		HUnlock(hmsg);
		pXCmd->returnValue = hmsg;
		}   
	return;
}


#define	min(a,b)	(a<b) ? a : b
#define	max(a,b)	(a>b) ? a : b
#define	Isalpha(c)		((c >= 'A' & c <= 'Z') \
										|  (c >= 'a' & c <= 'z'))

int Toupper(char c)
{
	return( (c>='a')&&(c<='z') ? (c-('a'-'A')) : c );
}


void upcase(char *s)
{
	int i,l;
	l = strlen(s);
	for (i=0;i<l;i++) s[i] = Toupper(s[i]);
}

	 
void stripcontrols(XCmdPtr pXCmd)
{
	Handle 	hbin;
	char		*c, *b;
	long		len;
	
	hbin = (pXCmd->params[1]); /*! HC param is read-only !*/
  HandToHand(&hbin); 
	HLock(hbin);
	for (c = *hbin, b = *hbin; *c != 0; c++) {
	  if ((*c >= ' ') || (*c == '\n')) *b++ = *c;
		}
	*b = 0; 
	len = b - hbin + 1;
	HUnlock( hbin);
	SetHandleSize( hbin, len);
  pXCmd->returnValue = hbin; 
} /* stripcontrols */





